#!/usr/bin/env python

from collections import defaultdict

############# BOTTOM-UP LCS #############

def backTrack(C, X, Y, i, j):
    if i == 0 or j == 0:
        return ""
    elif X[i-1] == Y[j-1]:
        return backTrack(C, X, Y, i-1, j-1) + X[i-1]
    else:
        if C[(i,j-1)] > C[(i-1,j)]:
            return backTrack(C, X, Y, i, j-1)
        else:
            return backTrack(C, X, Y, i-1, j)

def LCS(X, Y):
    m = len(X)
    n = len(Y)
    C = defaultdict(lambda: 0)
    for i in range(1, m+1):
        for j in range(1, n+1):
            if X[i-1] == Y[j-1]: 
                C[(i,j)] = C[(i-1,j-1)] + 1
            else:
                C[(i,j)] = max(C[(i,j-1)], C[(i-1,j)])
    return C

if __name__ == "__main__":
    X = "AATCC"
    Y = "ACACG"
    m = len(X)
    n = len(Y)
    C = LCS(X, Y)
    print "LCS length :: %s" % (C[(m,n)])
    print "A possible LCS :: %s" % backTrack(C, X, Y, m, n)