#!/usr/bin/env python

from collections import defaultdict
import sys

############## TOP-DOWN MATRIX ############

def memoize(p):
    m = defaultdict(lambda: sys.maxint)
    s = defaultdict(lambda: -1)
    n = len(p)
    return look_up(m,p,1,n-1)

def look_up(m,p,i,j):
    if m[(i,j)] < sys.maxint:
        return m[(i,j)]
    if i == j:
        m[(i,j)] = 0
    else:
        for k in range(i,j):
            r_i = p[i][0]
            c_i = p[k][1]
            c_j = p[j][1]
            q = look_up(m,p,i,k) + look_up(m,p,k+1,j) + (r_i*c_i*c_j)
            if q < m[(i,j)]:
                m[(i,j)] = q
    return m[(i,j)]

if __name__ == "__main__":
    a1 = (30,35)
    a2 = (35,15)
    a3 = (15,5)
    a4 = (5,10)
    a5 = (10,20)
    a6 = (20,25)
    p = [None,a1, a2, a3, a4, a5, a6]
    print "min. number of operations needed :: ", memoize(p)